/* Copyright 1998-2011 Research Foundation State University of New York */

/* This file is part of QuB.                                            */

/* QuB is free software; you can redistribute it and/or modify          */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation, either version 3 of the License, or    */
/* (at your option) any later version.                                  */

/* QuB is distributed in the hope that it will be useful,               */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/* GNU General Public License for more details.                         */

/* You should have received a copy of the GNU General Public License,   */
/* named LICENSE.txt, in the QuB program directory.  If not, see        */
/* <http://www.gnu.org/licenses/>.                                      */

#ifndef QTR_NODEFUNCPY_H
#define QTR_NODEFUNCPY_H

#include "qubtree_node.h"
#include <QTR_NodeFunc.h>

class QTR_PY_API QTR_NodePyFunc : public QTR_NodeFunc
{
public:
	QTR_NodePyFunc( PyObject *fn );
	virtual ~QTR_NodePyFunc();
	virtual QUB_Tree NodeCall( QUB_Tree arg );
private:
	PyObject *func;
};

class QTR_PY_API QTR_NodeNodePyFunc : public QTR_NodeNodeFunc
{
public:
	QTR_NodeNodePyFunc( PyObject *fn );
	virtual ~QTR_NodeNodePyFunc();
	virtual QUB_Tree NodeNodeCall( QUB_Tree arg1, QUB_Tree arg2 );
private:
	PyObject *func;
};

#endif
